> ## Documentation Index
> Fetch the complete documentation index at: https://www.canva.dev/docs/apps/llms.txt
> Use this file to discover all available pages before exploring further.
# List designs
List all the user's designs.
Lists metadata for all the designs in a Canva user's
[projects](https://www.canva.com/help/find-designs-and-folders/). You can also:
* Use search terms to filter the listed designs.
* Show designs either created by, or shared with the user.
* Sort the results.
## HTTP method and URL path
GET https\://api.canva.com/rest/v1/designs
This operation is rate limited to 100 requests per minute for each user of your app.
## Authentication and authorization
This endpoint requires a valid access token that acts on behalf of a user. For more information, see [Generate an access token](/docs/apps/rest-apis/reference/authentication/generate-access-token).
### Scopes
The access token must have all the following [scopes](/docs/apps/rest-apis/scopes) (permissions):
* `design:meta:read`
## Header parameters
Provides credentials to authenticate the request, in the form of a `Bearer` token.
For example: `Authorization: Bearer {token}`
## Query parameters
Lets you search the user's designs, and designs shared with the user, using a search term or terms.
**Maximum length:** `255`
If the success response contains a continuation token, the list contains more designs
you can list. You can use this token as a query parameter and retrieve more
designs from the list, for example
`/v1/designs?continuation={continuation}`.
To retrieve all of a user's designs, you might need to make multiple requests.
Filter the list of designs based on the user's ownership of the designs.
**Default value:** `any`
**Available values:**
* `any`: Owned by and shared with the user.
* `owned`: Owned by the user.
* `shared`: Shared with the user.
Sort the list of designs.
**Default value:** `relevance`
**Available values:**
* `relevance`: Sort results using a relevance algorithm.
* `modified_descending`: Sort results by the date last modified in descending order.
* `modified_ascending`: Sort results by the date last modified in ascending order.
* `title_descending`: Sort results by title in descending order.
* `title_ascending`: Sort results by title in ascending order
The number of designs to return.
**Minimum:** `1`
**Maximum:** `100`
**Default value:** `25`
## Example request
Examples for using the `/v1/designs` endpoint:
```sh
curl --request GET 'https://api.canva.com/rest/v1/designs' \
--header 'Authorization: Bearer {token}'
```
```js
const fetch = require("node-fetch");
fetch("https://api.canva.com/rest/v1/designs", {
method: "GET",
headers: {
"Authorization": "Bearer {token}",
},
})
.then(async (response) => {
const data = await response.json();
console.log(data);
})
.catch(err => console.error(err));
```
```java
import java.io.IOException;
import java.net.URI;
import java.net.http.*;
public class ApiExample {
public static void main(String[] args) throws IOException, InterruptedException {
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://api.canva.com/rest/v1/designs"))
.header("Authorization", "Bearer {token}")
.method("GET", HttpRequest.BodyPublishers.noBody())
.build();
HttpResponse response = HttpClient.newHttpClient().send(
request,
HttpResponse.BodyHandlers.ofString()
);
System.out.println(response.body());
}
}
```
```py
import requests
headers = {
"Authorization": "Bearer {token}"
}
response = requests.get("https://api.canva.com/rest/v1/designs",
headers=headers
)
print(response.json())
```
```csharp
using System.Net.Http;
var client = new HttpClient();
var request = new HttpRequestMessage
{
Method = HttpMethod.Get,
RequestUri = new Uri("https://api.canva.com/rest/v1/designs"),
Headers =
{
{ "Authorization", "Bearer {token}" },
},
};
using (var response = await client.SendAsync(request))
{
response.EnsureSuccessStatusCode();
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
};
```
```go
package main
import (
"fmt"
"io"
"net/http"
)
func main() {
url := "https://api.canva.com/rest/v1/designs"
req, _ := http.NewRequest("GET", url, nil)
req.Header.Add("Authorization", "Bearer {token}")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
```
```php
$curl = curl_init();
curl_setopt_array($curl, array(
CURLOPT_URL => "https://api.canva.com/rest/v1/designs",
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array(
'Authorization: Bearer {token}',
),
));
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if (empty($err)) {
echo $response;
} else {
echo "Error: " . $err;
}
```
```ruby
require 'net/http'
require 'uri'
url = URI('https://api.canva.com/rest/v1/designs')
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request['Authorization'] = 'Bearer {token}'
response = http.request(request)
puts response.read_body
```
## Success response
If successful, the endpoint returns a `200` response with a JSON body with the following parameters:
The list of designs.
Properties of items>} defaultExpanded={true}>
The design ID.
Metadata for the user, consisting of the User ID and Team ID.
Properties of owner>}>
The ID of the user.
The ID of the user's Canva Team.
A temporary set of URLs for viewing or editing the design.
Properties of urls>}>
A temporary editing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support [return navigation](https://www.canva.dev/docs/apps/rest-apis/return-navigation-guide/) workflows.
NOTE: This is not a permanent URL, it is only valid for 30 days.
A temporary viewing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support [return navigation](https://www.canva.dev/docs/apps/rest-apis/return-navigation-guide/) workflows.
NOTE: This is not a permanent URL, it is only valid for 30 days.
When the design was created in Canva, as a Unix timestamp (in seconds since the Unix
Epoch).
When the design was last updated in Canva, as a Unix timestamp (in seconds since the
Unix Epoch).
The type of content a design or page contains. The list of design types may grow over time. The `unknown` value represents design types that haven't been added to the list.
**Available values:**
* `doc`
* `email`
* `presentation`
* `sheet`
* `whiteboard`
* `custom`
* `unknown`
The design title.
A thumbnail image representing the object.
Properties of thumbnail>}>
The width of the thumbnail image in pixels.
The height of the thumbnail image in pixels.
A URL for retrieving the thumbnail image.
This URL expires after 15 minutes. This URL includes a query string
that's required for retrieving the thumbnail.
The total number of pages in the design. Some design types don't have pages (for example, Canva docs).
A continuation token.
If the success response contains a continuation token, the list contains more designs
you can list. You can use this token as a query parameter and retrieve more
designs from the list, for example
`/v1/designs?continuation={continuation}`.
To retrieve all of a user's designs, you might need to make multiple requests.
## Example response
```json
{
"continuation": "RkFGMgXlsVTDbMd:MR3L0QjiaUzycIAjx0yMyuNiV0OildoiOwL0x32G4NjNu4FwtAQNxowUQNMMYN",
"items": [
{
"id": "DAFVztcvd9z",
"title": "My summer holiday",
"owner": {
"user_id": "auDAbliZ2rQNNOsUl5OLu",
"team_id": "Oi2RJILTrKk0KRhRUZozX"
},
"thumbnail": {
"width": 595,
"height": 335,
"url": "https://document-export.canva.com/Vczz9/zF9vzVtdADc/2/thumbnail/0001.png?"
},
"urls": {
"edit_url": "https://www.canva.com/api/design/eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2R0NNIiwiZXhwaXJ5IjoxNzQyMDk5NDAzMDc5fQ..GKLx2hrJa3wSSDKQ.hk3HA59qJyxehR-ejzt2DThBW0cbRdMBz7Fb5uCpwD-4o485pCf4kcXt_ypUYX0qMHVeZ131YvfwGPIhbk-C245D8c12IIJSDbZUZTS7WiCOJZQ.sNz3mPSQxsETBvl_-upMYA/edit",
"view_url": "https://www.canva.com/api/design/eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2R0NNIiwiZXhwaXJ5IjoxNzQyMDk5NDAzMDc5fQ..GKLx2hrJa3wSSDKQ.hk3HA59qJyxehR-ejzt2DThBW0cbRdMBz7Fb5uCpwD-4o485pCf4kcXt_ypUYX0qMHVeZ131YvfwGPIhbk-C245D8c12IIJSDbZUZTS7WiCOJZQ.sNz3mPSQxsETBvl_-upMYA/view"
},
"created_at": 1377396000,
"updated_at": 1692928800,
"page_count": 5,
"design_types": [
"presentation"
]
}
]
}
```
## Error responses
### 400 Bad Request
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error responses
##### The continuation token is invalid
```json
{
"code": "bad_query_params",
"message": "Invalid continuation: {continuation}"
}
```
##### The ownership value is invalid
```json
{
"code": "invalid_field",
"message": "Invalid ownership"
}
```
##### The sort\_by value is invalid
```json
{
"code": "invalid_field",
"message": "Invalid sort by value: {sortBy}"
}
```
##### The design\_types filter contains an unavailable design type
```json
{
"code": "invalid_field",
"message": "'design_types' contains a design type that isn't available: {designType}."
}
```
##### Unable to fetch designs
```json
{
"code": "bad_query_params",
"message": "Unable to fetch designs"
}
```
### 403 Forbidden
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error responses
##### Not allowed to access the design list
```json
{
"code": "permission_denied",
"message": "Not allowed to access design list"
}
```
##### Not allowed to find documents
```json
{
"code": "permission_denied",
"message": "Not allowed to find documents"
}
```